package com.sky.ioc.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sky.ioc.entity.domain.parking.Park;
import com.sky.ioc.entity.params.IocParam;
import com.sky.ioc.entity.params.IocTimeRange;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

@Mapper
public interface ParkMapper extends BaseMapper<Park> {
    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            "<![CDATA[ and entry_time > #{iocParam.timeRange.startDate} " +
            " and  entry_time < #{iocParam.timeRange.endDate} ]]>" +

            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptId(@Param("iocParam") IocParam iocParam);

    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            " <![CDATA[ and entry_time > #{iocParam.timeRange.startDate} and entry_time < #{iocParam.timeRange.endDate} ]]> " +
            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptIdAndEntryTime(@Param("iocParam") IocParam iocParam);

    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null '>" +
            " <![CDATA[ and departure_time > #{iocParam.timeRange.startDate} and departure_time < #{iocParam.timeRange.endDate} ]]>" +
            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptIdAndDepartureTime(@Param("iocParam") IocParam iocParam);



}
