package com.sky.ioc.service.space.impl;

import com.sky.ioc.entity.domain.meeting.MeetingRoom;
import com.sky.ioc.entity.domain.space.BuildingRoom;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.mapper.space.BuildingRoomMapper;
import com.sky.ioc.service.space.BuildingRoomService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
@Slf4j
public class BuildingRoomServiceImpl implements BuildingRoomService {

    @Autowired
    BuildingRoomMapper buildingRoomMapper;

    @Autowired
    TokenMapper tokenMapper;

    final static  String BUILDING_ROOM_URL="http://192.168.1.45:9001/api/space/SPACE/roomArea/list?pageNum=1&pageSize=90000";


    @Override
    public ReturnMsg getBuildingRoomList() {
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        // 创建一个请求头对象
        HttpHeaders httpHeaders = new HttpHeaders();
        // 设置参数
        httpHeaders.set("authorization", token);
        // 创建一个响应体对象
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        // 3.创建RestTemplate
        RestTemplate restTemplate = new RestTemplate();
        // 发送GET请求
        ResponseEntity<Map> responseEntity = restTemplate.exchange(BUILDING_ROOM_URL, HttpMethod.GET, httpEntity, Map.class);
        // 获取响应对象里的 body 对象
        Map<String, Object> body = responseEntity.getBody();
        // 获取状态码
        Integer code = (Integer)body.get("code");
        // 获取响应信息
        String message = (String)body.get("msg");
        if(code==200){
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                buildingRoomMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    BuildingRoom room = new BuildingRoom();
                    room.setId((Integer) json.get("id"));
                    room.setName((String) json.get("name"));
                    room.setFloorId(Integer.parseInt(String.valueOf(json.get("floorId"))));
                    room.setBuildingId(Integer.parseInt(String.valueOf(json.get("buildingId"))));
                    room.setBuildingArea(String.valueOf(json.get("buildingArea")));
                    room.setUseableArea(String.valueOf(json.get("usableArea")));
                    room.setPublicArea(String.valueOf(json.get("publicArea")));
                    room.setCode(String.valueOf(json.get("code")));
                    room.setDeptId(Integer.parseInt(String.valueOf(json.get("officeId"))));
                    room.setStatus(Integer.parseInt(String.valueOf(json.get("status"))));
                    room.setIsDel(Integer.parseInt(String.valueOf(json.get("delFlag"))));
                    buildingRoomMapper.insert(room);
                }
            }
            return ReturnMsg.ok();
        }else{
            log.info("获取楼层房间数据："+message);
            return ReturnMsg.fail(message);
        }
    }
}
